program Mind_by_MysticWare;

{/* Little program for two purposes:
     - Let's you run RA 2.5 doors, which requires .RDX files, with RA 2.0x.
     - Program RA 2.5 doors without having to install RA 2.5.

    ATTENTION!
     - Don't run with RA 2.5 or your configuration gets mixed up.
     - Don't run doors/tools which
        1. Adds, deletes or moves a group or area.
        2. Changes the AreaNum field of any record.                      */}

uses Crt,DOS;

const  ProgramName    = 'Mind';
       ProgramVersion = '1.0';
       LastUpdate     = '1st February 1996';

       ReadMode      = 0;       WriteMode     = 1;       ReadWriteMode = 2;
       DenyAll       = $10;     DenyWrite     = $20;     DenyRead      = $30;
       DenyNone      = $40;     Inheritance   = $80;

type   FlagType      = array[1..4] of Byte;
       MsgKindsType  = (Both, Private, Public, ROnly, NoReply);
       MsgType       = (LocalMail, NetMail, EchoMail, Internet, Newsgroup);

  GROUPrecord    = record                           { MGROUPS.RA / FGROUPS.RA }
                     AreaNum        : Word;                  { Number of Area }
                     Name           : String[40];             { Name of group }
                     Security       : Word;                 { Security needed }
                     Flags,                                    { Flags needed }
                     NotFlagsMask   : FlagType;           { Flags not allowed }
                     FreeSpace      : Array[1..100] of Byte;
                   end; { GROUPrecord }

  FILESrecord    = record                                          { Files.RA }
                     AreaNum        : Word;                  { Number of area }
                     Unused         : Word;
                     Name           : String[40];              { Name of area }
                     Attrib         : Byte;{Bit 0 : Include in new files scan }
                                        { Bit 1 : Include in upload dupe scan }
                                           { Bit 2 : Permit long descriptions }
                                                  { Bit 3 : Area is on CD-ROM }
                                                 { Bit 4 : All files are FREE }
                                               { Bit 5 : Allow DLs not in FDB }
                                    { Bit 6 : Allow users to password uploads }
                                                       { Bit 7 : Scan uploads }
                     FilePath       : String[40];         { DOS Path to files }
                     KillDaysDL,         { Days to keep since last downloaded }
                     KillDaysFD     : Word;      { Days to keep ( file date ) }
                     Password       : String[15];         { Password for area }
                     MoveArea       : Word;       { Move to area # (0=delete) }
                     Age,                                        { Age needed }
                     ConvertExt     : Byte;                      { convert to }
                     Group          : Word;                           { Group }
                     Attrib2        : Byte;   { Bit 0 : Include in all groups }
                     DefCost,                                         { costs }
                     UploadArea,                      { alternate upload area }
                     UploadSecurity : Word;                 { upload security }
                     UploadFlags,                              { upload flags }
                     UploadNotFlags : FlagType;            { upload not flags }
                     Security       : Word;               { download security }
                     Flags,                                  { download flags }
                     NotFlags       : FlagType;          { download not flags }
                     ListSecurity   : Word;                   { list security }
                     ListFlags,                                  { list flags }
                     ListNotFlags   : FlagType;              { list not flags }
                     AltGroup       : Array[1..3] of Word; { alternate groups }
                     Device         : Byte;                          { device }
                     FreeSpace      : Array[1..13] of Byte;        { reseverd }
                   end; { FILESrecord }

   MESSAGErecord = record                                      { Messages.RA }
                     AreaNum        : Word;                  { Number of area}
                     Unused         : Word;
                     Name           : String[40];         { Name of MSG-Area }
                     Typ            : MsgType;               { Msg-Area type }
                     MsgKinds       : MsgKindsType;           { Kind of Msgs }
                     Attribute      : Byte;        { Bit 0 : Enable EchoInfo }
                                                   { Bit 1 : Combined access }
                                                     { Bit 2 : File attaches }
                                                     { Bit 3 : Allow aliases }
                                         { Bit 4 : Use SoftCRs as characters }
                                                      { Bit 5 : Force handle }
                                                     { Bit 6 : Allow deletes }
                                                     { Bit 7 : Is a JAM area }
                     DaysKill,                    { Kill older than 'x' days }
                     RecvKill       : Byte;  { Kill recv msgs after 'x' days }
                     CountKill      : Word;   { Maximum msgs allowed in area }
                     ReadSecurity   : Word;                   { Read security }
                     ReadFlags,                                  { Read flags }
                     ReadNotFlags   : FlagType;              { Read not flags }
                     WriteSecurity  : Word;                  { Write security }
                     WriteFlags,                                { Write flags }
                     WriteNotFlags  : FlagType;             { Write not flags }
                     SysopSecurity  : Word;                  { Sysop security }
                     SysopFlags,                                { Sysop flags }
                     SysopNotFlags  : FlagType;             { Sysop not flags }
                     OriginLine     : String[60];               { Origin line }
                     AkaAddress     : Byte;                      { Aka to use }
                     Age            : Byte;                      { Age needed }
                     JAMbase        : String[60];      { Directory of jamBase }
                     Group          : Word;                      { Main group }
                     AltGroup       : Array[1..3] of Word;{Alternative groups }
                     Attribute2     : Byte;   { Bit 0 : Include in all groups }
                     NetmailArea    : Word;
                     FreeSpace2     : Array[1..7] of Byte;
                   end; { MESSAGErecord }

var    FILESfile  :file of FILESrecord;    GROUPfile  :file of GROUPrecord;
       MESSAGEfile:file of MESSAGErecord;  RDXfile    :file of Word;
       FILESdata  :FILESrecord;            GROUPdata  :GROUPrecord;
       MESSAGEdata:MESSAGErecord;          RAsystem   :String;

procedure DosError(Text:String);
begin
  if WhereX>1 then WriteLn;
  WriteLn(#7,ProgramName+' '+ProgramVersion+': '+Text);  Halt(255);
end;

procedure CheckFile(FileName:String);
var f:file;
begin
  {$I-} FileMode:=DenyNone;  Assign(f,FileName);  Reset(F);  Close(F); {$I+}
  if not (IOResult=0) and (FileName<>'') then DosError('Cannot find '+FileName+'!');
end;

function UpString(ConvString:String):String;
var i:integer;
begin
  for i:=1 to Length(ConvString) do ConvString[i]:=UpCase(ConvString[i]);
  UpString:=ConvString;
end;

begin
{What shall I do?}
  if (ParamCount=0) or (ParamStr(1)='/?') or (ParamStr(1)='-?') then
  begin
    WriteLn(ProgramName+' '+ProgramVersion+'   FreeWare by MysticWare   Last Update: '+LastUpdate);
    WriteLn;
    WriteLn(' MIND [/?] [/IDX]');
    WriteLn;
    WriteLn('        /? The text you are reading');
    WriteLn('      /IDX Create RA 2.5 index-files');
    WriteLn;
    WriteLn('Written by Stephan Binner@2:2410/1007');
    Halt(0);
  end;
  if UpString(ParamStr(1))<>'/IDX' then Halt(1);
{Where is RA?}
  RAsystem:=GetEnv('RA');
  if RAsystem='' then DosError('RA-Environment must be set!');
  if RAsystem[Length(RAsystem)]<>'\' then RAsystem:=RAsystem+'\';
{Something missing?}
  CheckFile(RAsystem+'FILES.RA');     CheckFile(RAsystem+'FGROUPS.RA');
  CheckFile(RAsystem+'MESSAGES.RA');  CheckFile(RAsystem+'MGROUPS.RA');
  WriteLn(ProgramName+' '+ProgramVersion+': Creating indices.');
  WriteLn;  FileMode:=ReadWriteMode+DenyNone;
{Create FILES.RDX}
  Assign(FILESfile,RAsystem+'FILES.RA');  Reset(FILESfile);
  {$I-} Assign(RDXfile,RAsystem+'FILES.RDX');  Rewrite(RDXfile); {$I+}
  if IOResult<>0 then DosError('Cannot write '+RAsystem+'FILES.RDX');
  while not eof(FILESfile) do
  begin
    Read(FILESfile,FILESdata);
    FILESdata.AreaNum:=FilePos(FILESfile);
    Write(RDXfile,FILESdata.AreaNum);
    Seek(FILESfile,FilePos(FILESfile)-1);  Write(FILESfile,FILESdata);
    GotoXY(1,WhereY);  Write(FilePos(FILESfile):5,' file-areas processed.');
  end;
  Close(FILESfile);  Close(RDXfile);  WriteLn;
{Create FGROUPS.RDX}
  Assign(GROUPfile,RAsystem+'FGROUPS.RA');  Reset(GROUPfile);
  {$I-} Assign(RDXfile,RAsystem+'FGROUPS.RDX');  Rewrite(RDXfile); {$I+}
  if IOResult<>0 then DosError('Cannot write '+RAsystem+'FGROUPS.RDX');
  while not eof(GROUPfile) do
  begin
    Read(GROUPfile,GROUPdata);
    GROUPdata.AreaNum:=FilePos(GROUPfile);
    Write(RDXfile,GROUPdata.AreaNum);
    Seek(GROUPfile,FilePos(GROUPfile)-1);
    Write(GROUPfile,GROUPdata);
    GotoXY(1,WhereY);  Write(FilePos(GROUPfile):5,' filegroups processed.');
  end;
  Close(GROUPfile);  Close(RDXfile);  WriteLn;  WriteLn;
{Create MESSAGES.RDX}
  Assign(MESSAGEfile,RAsystem+'MESSAGES.RA');  Reset(MESSAGEfile);
  {$I-} Assign(RDXfile,RAsystem+'MESSAGES.RDX');  Rewrite(RDXfile); {$I+}
  if IOResult<>0 then DosError('Cannot write '+RAsystem+'MESSAGES.RDX');
  while not eof(MESSAGEfile) do
  begin
    Read(MESSAGEfile,MESSAGEdata);
    MESSAGEdata.AreaNum:=FilePos(MESSAGEfile);
    Write(RDXfile,MESSAGEdata.AreaNum);
    Seek(MESSAGEfile,FilePos(MESSAGEfile)-1);
    Write(MESSAGEfile,MESSAGEdata);
    GotoXY(1,WhereY);  Write(FilePos(MESSAGEfile):5,' msg-areas processed.');
  end;
  Close(MESSAGEfile);  Close(RDXfile);  WriteLn;
{Create MGROUPS.RDX}
  Assign(GROUPfile,RAsystem+'MGROUPS.RA');  Reset(GROUPfile);
  {$I-} Assign(RDXfile,RAsystem+'MGROUPS.RDX');  Rewrite(RDXfile); {$I+}
  if IOResult<>0 then DosError('Cannot write '+RAsystem+'MGROUPS.RDX');
  while not eof(GROUPfile) do
  begin
    Read(GROUPfile,GROUPdata);
    GROUPdata.AreaNum:=FilePos(GROUPfile);
    Write(RDXfile,GROUPdata.AreaNum);
    Seek(GROUPfile,FilePos(GROUPfile)-1);
    Write(GROUPfile,GROUPdata);
    GotoXY(1,WhereY);  Write(FilePos(GROUPfile):5,' msggroups processed.');
  end;
  Close(GROUPfile);  Close(RDXfile);  WriteLn;  WriteLn;
{The End}
  WriteLn(ProgramName+' '+ProgramVersion+': All Done.');
end.